From: Edward Betts <edward@4angle.com>
Date: Thu, 18 Aug 2022 17:15:39 +0100
Subject: Avoid network access during tests

---
 test/test_advocate.py | 11 +++++++++++
 1 file changed, 11 insertions(+)

diff --git a/test/test_advocate.py b/test/test_advocate.py
index f676d8c..f16a8a6 100644
--- a/test/test_advocate.py
+++ b/test/test_advocate.py
@@ -40,6 +40,8 @@ global_wrapper = RequestsAPIWrapper(validator=AddrValidator(ip_whitelist={
 }))
 RequestsAPIWrapper.SUPPORT_WRAPPER_PICKLING = False
 
+network_access = False  # Avoid network access during Debian build and autopkgtest
+
 
 class _WrapperSubclass(global_wrapper.Session):
     def good_method(self):
@@ -52,6 +54,8 @@ def canonname_supported():
     travis-ci.org's Python 3 env doesn't seem to support it, so don't try
     any of the test that rely on it.
     """
+    if not network_access:
+        return False
     addrinfo = advocate_getaddrinfo("example.com", 0, get_canonname=True)
     assert addrinfo
     return addrinfo[0][3] == b"example.com"
@@ -74,6 +78,7 @@ def permissive_validator(**kwargs):
 
 
 # Test our test wrappers to make sure they're testy
+@unittest.skipUnless(network_access, "network access disabled")
 class TestWrapperTests(unittest.TestCase):
     def test_unsafe_connect_raises(self):
         self.assertRaises(
@@ -243,6 +248,7 @@ class AddrInfoTests(unittest.TestCase):
             self._is_addrinfo_allowed("192.168.0.1", 80)
         )
 
+    @unittest.skipUnless(network_access, "network access disabled")
     def test_malformed_addrinfo(self):
         # Alright, the addrinfo format is probably never going to change,
         # but *what if it did?*
@@ -250,6 +256,7 @@ class AddrInfoTests(unittest.TestCase):
         addrinfo = advocate_getaddrinfo("example.com", 80)[0] + (1,)
         self.assertRaises(Exception, lambda: vl.is_addrinfo_allowed(addrinfo))
 
+    @unittest.skipUnless(network_access, "network access disabled")
     def test_unexpected_proto(self):
         # What if addrinfo returns info about a protocol we don't understand?
         vl = permissive_validator()
@@ -403,6 +410,7 @@ class HostnameTests(unittest.TestCase):
         self.assertFalse(vl.is_hostname_allowed(u"foo.example.com\x00.baz.com"))
 
 
+@unittest.skipUnless(network_access, "network access disabled")
 class ConnectionPoolingTests(unittest.TestCase):
     @patch("advocate.connection.ValidatingHTTPConnection._new_conn")
     def test_connection_reuse(self, mock_new_conn):
@@ -424,6 +432,7 @@ class ConnectionPoolingTests(unittest.TestCase):
 
 
 class AdvocateWrapperTests(unittest.TestCase):
+    @unittest.skipUnless(network_access, "network access disabled")
     def test_get(self):
         self.assertEqual(advocate.get("http://example.com").status_code, 200)
         self.assertEqual(advocate.get("https://example.com").status_code, 200)
@@ -589,6 +598,7 @@ class AdvocateWrapperTests(unittest.TestCase):
             },
         )
 
+    @unittest.skipUnless(network_access, "network access disabled")
     @patch("advocate.addrvalidator.determine_local_addresses")
     def test_connect_without_local_addresses(self, mock_determine_local_addresses):
         fake_addresses = [ipaddress.ip_network("200.1.1.1")]
@@ -606,6 +616,7 @@ class AdvocateWrapperTests(unittest.TestCase):
         mock_determine_local_addresses.assert_not_called()
 
 
+@unittest.skipUnless(network_access, "network access disabled")
 class AdvocateFuturesTest(unittest.TestCase):
     def test_get(self):
         sess = FuturesSession()
